<#ibiztemplate>
FILENAME=${app.getPKGCodeName()}${item.codeName}AppMenuModel.java
PUBOBJ=SysAppMenuModelCode
%PUBPKG%=${pub.getPKGCodeName()?replace('.','/')}
%APPFOLDER%=${app.getAppFolder()?lower_case}
</#ibiztemplate>
package ${pub.getPKGCodeName()}.${app.getAppFolder()?lower_case}.srv.sys.ctrlmodel;


import java.util.ArrayList;
import net.ibizsys.paas.util.StringHelper;
import net.ibizsys.paas.web.AjaxActionResult;
import net.ibizsys.paas.web.WebContext;
import net.ibizsys.paas.web.WebContext;
import net.ibizsys.paas.data.IDataObject;

import net.ibizsys.paas.web.WebConfig;
import net.ibizsys.paas.control.menu.AppMenuItem;
import net.ibizsys.paas.control.menu.AppMenuRootItem;
import net.ibizsys.paas.control.menu.AppMenuUtils;
import net.ibizsys.paas.ctrlmodel.AppMenuModelGlobal;
import java.io.File;
import javax.annotation.PostConstruct;
import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
<#if item.getControlType()=='APPMENU'>
import org.springframework.stereotype.Component;
</#if>
/**
 * <#if item.getControlType()=='APPMENU'>应用菜单</#if><#if item.getControlType()=='PORLET'>门户部件</#if>[${item.codeName}]模型基类
 */
<#if item.getControlType()=='APPMENU'>@Component</#if>
public class  ${app.getPKGCodeName()}${item.codeName}${srfclassname('${item.getControlType()}')}Model extends ${pub.getBaseClassPKGCodeName()}.paas.ctrlmodel.${srfclassname('${item.getControlType()}')}ModelBase{
	private Log log = LogFactory.getLog(${app.getPKGCodeName()}${item.codeName}${srfclassname('${item.getControlType()}')}Model.class);
   
    public ${app.getPKGCodeName()}${item.codeName}${srfclassname('${item.getControlType()}')}Model()  {
        super();
        this.setName("${item.codeName}");
<#if item.isEnableCustomize()>
        this.setId("${srfjavastring('${item.id}')}");
        this.setEnableCustomize(true);
</#if>

    }
  
    @Override
    protected void onInit() throws Exception
    {
       super.onInit();
    }

    /**
     * 注解Spring构造后执行
     * @throws Exception
     */
    @PostConstruct  
    public void postConstruct() throws Exception{
    	super.init();
        AppMenuModelGlobal.registerAppMenuModel("${pub.getPKGCodeName()}.${app.getAppFolder()?lower_case}.srv.sys.ctrlmodel.${app.getPKGCodeName()}${item.codeName}${srfclassname('${item.getControlType()}')}Model",this);
        AppMenuModelGlobal.registerAppMenuModel("${srfjavastring('${item.id}')}",this);
    }

    /**
     * 准备应用菜单根节点
     * @param appMenuRootItem
     * @throws Exception
     */
    @Override
    protected void onPrepareRootItem(AppMenuRootItem appMenuRootItem) throws Exception{
    	//从Xml文件加载菜单项
    	boolean bSuccessLoaded = this.loadAppMenuRootItem(appMenuRootItem);
        if(bSuccessLoaded)
        	appMenuRootItem = new AppMenuRootItem();

<#list item.getRootItem().getAllItems() as appmenuitem> 
        //添加 ${appmenuitem.text}
        AppMenuItem appMenuItem${appmenuitem_index?c} = appMenuRootItem.addItem("${appmenuitem.id}","${appmenuitem.getPId()}");
<#if appmenuitem.getAppFuncId()??>
        appMenuItem${appmenuitem_index?c}.setAppFuncId("${appmenuitem.getAppFuncId()}");
</#if>
<#if appmenuitem.getItemType()??>
        appMenuItem${appmenuitem_index?c}.setItemType("${appmenuitem.getItemType()}");
</#if>
	appMenuItem${appmenuitem_index?c}.setText("${appmenuitem.text}");
	<#if appmenuitem.getTextLanResTag()??>
	appMenuItem${appmenuitem_index?c}.setTextLanResTag("${appmenuitem.getTextLanResTag()}");
	</#if>
	<#if appmenuitem.getTooltip()??>
	appMenuItem${appmenuitem_index?c}.setTooltip("${appmenuitem.getTooltip()}");
	</#if>
	<#if appmenuitem.getTooltipLanResTag()??>
	appMenuItem${appmenuitem_index?c}.setTooltipLanResTag("${appmenuitem.getTooltipLanResTag()}");
	</#if>
 <#if appmenuitem.isExpanded()>
        appMenuItem${appmenuitem_index?c}.setExpanded(true);
</#if>
 <#if appmenuitem.isSeperator()>
        appMenuItem${appmenuitem_index?c}.setSeperator(true);
</#if>
 <#if appmenuitem.isHidden()>
        appMenuItem${appmenuitem_index?c}.setHidden(true);
</#if>
 <#if appmenuitem.isHideSideBar()>
        appMenuItem${appmenuitem_index?c}.setHideSideBar(true);
</#if>
 <#if appmenuitem.isOpenDefault()>
        appMenuItem${appmenuitem_index?c}.setOpenDefault(true);
</#if>
<#if appmenuitem.getPSSysImage()??>
        appMenuItem${appmenuitem_index?c}.setIconCls("${appmenuitem.getPSSysImage().getCssClass()}");
        appMenuItem${appmenuitem_index?c}.setIconPath("${appmenuitem.getPSSysImage().getImagePath()}");
</#if>
<#if appmenuitem.getPSSysCss()??>
        appMenuItem${appmenuitem_index?c}.setTextCls("${appmenuitem.getPSSysCss().getCssName()}");
</#if>
<#if (appmenuitem.getAccUserMode() gt 0)>
        appMenuItem${appmenuitem_index?c}.setAccUserMode(${appmenuitem.getAccUserMode()?c});
</#if>
<#if (appmenuitem.getAccessKey()??)>
        appMenuItem${appmenuitem_index?c}.setAccessKey("${appmenuitem.getAccessKey()}");
        appMenuItem${appmenuitem_index?c}.setAccUserMode(4);//强制设置值 
</#if>
<#if appmenuitem.getCounterId()??>
        appMenuItem${appmenuitem_index?c}.setCounterId("${appmenuitem.getCounterId()}");
</#if>
<#if appmenuitem.getFillerObj()??>
        appMenuItem${appmenuitem_index?c}.setFillerObj("${appmenuitem.getFillerObj()}");
</#if>
</#list>	

        if(WebConfig.getCurrent().getAttribute("EXPORTMENUCONF", false)){
        	//菜单项写入Xml文件
        	this.writeAppMenuRootItem(appMenuRootItem);
        }
    }

    /**
     * 从菜单配置文件加载菜单项
     * @return
     */
    protected boolean loadAppMenuRootItem(AppMenuRootItem appMenuRootItem){
    	try {
			String strMenuConfigFileName = this.getMenuConfigFileName(false);
			File file = new File(strMenuConfigFileName);
			if(!file.exists())
				return false;
			
			AppMenuRootItem appMenuRootItem2 = AppMenuUtils.loadXmlFile(appMenuRootItem, strMenuConfigFileName);
			if(appMenuRootItem2 == null)
				return false;
			
			return true;
		} catch (Exception ex) {
			log.error(StringHelper.format("加载菜单配置数据发生错误！错误信息：%1$s", ex.getMessage()));
			ex.printStackTrace();
			return false;
		}
    }

    /**
     * 写菜单数据配置文件
     * @param appMenuRootItem
     */
    protected void writeAppMenuRootItem(AppMenuRootItem appMenuRootItem) {
        try {
            String strOriginMenuConfigFileName = this.getMenuConfigFileName(true);
            File file = new File(strOriginMenuConfigFileName);
            if(!file.exists()) {
            	File parentFile = new File(file.getParent());
            	if(!parentFile.exists())
            		parentFile.mkdirs();
            }

            //写菜单配置数据原始文件
            AppMenuUtils.writeXmlFile(appMenuRootItem, strOriginMenuConfigFileName);
        } catch (Exception ex) {
            log.error(StringHelper.format("写菜单配置数据发生错误！错误信息：%1$s", ex.getMessage()));
            ex.printStackTrace();
        }
    }

    /**
     * 获取菜单配置数据Xml文件路径
     * @return
     */
    protected String getMenuConfigFileName(Boolean bOriginName) {
        File file = new File(this.getClass().getResource("/").getPath());
        String strFileName = (this.getClass().getName()).replaceAll("\\.", "_");
        return StringHelper.format("%1$s%2$smenuconf%2$s%3$s%4$s.xml",file.getPath(), File.separator, bOriginName?"Origin_":"", strFileName);
    }
   
}