<#ibiztemplate>
FILENAME=${de.codeName}${item.codeName}UIActionModel.java
PUBOBJ=SysDEUIActionModelBaseCode
%PUBPKG%=${pub.getPKGCodeName()?replace('.','/')}
%DEMOD%=${de.getPSSystemModule().codeName?lower_case}
</#ibiztemplate>
package ${pub.getPKGCodeName()}.srv.${de.getPSSystemModule().codeName?lower_case}.demodel;

import net.ibizsys.paas.appmodel.IAppViewModel;
import net.ibizsys.paas.appmodel.IApplicationModel;
import net.ibizsys.paas.controller.ViewController;
import net.ibizsys.paas.util.StringHelper;
import net.ibizsys.paas.view.IUIActionModel;
import net.ibizsys.paas.web.UIActionModelAjaxActionResult;
import net.ibizsys.paas.web.WebContext;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.hibernate.SessionFactory;

import ${pub.getPKGCodeName()}.srv.${de.getPSSystemModule().codeName?lower_case}.entity.${de.codeName};
import ${pub.getPKGCodeName()}.srv.${de.getPSSystemModule().codeName?lower_case}.service.${de.codeName}Service;

/**
 *  实体界面行为[${item.name}]对象模型
 */
public class ${de.codeName}${item.codeName}UIActionModel extends ${pub.getBaseClassPKGCodeName()}.paas.demodel.DEUIActionModelBase<${de.codeName}>{
  
   private static final Log log = LogFactory.getLog(${de.codeName}${item.codeName}UIActionModel.class);

   public ${de.codeName}${item.codeName}UIActionModel(){
        super();

        this.setId("${srfjavastring('${item.id}')}");
        this.setName("${srfjavastring('${item.getUIActionTag()}')}");
        this.setActionTarget("${srfjavastring('${item.actionTarget}')}");
<#if item.getPSDEAction()??>
        this.setDEActionName("${srfjavastring('${item.getPSDEAction().name}')}");
</#if>
<#if item.isReloadData()>
        this.setReloadData(true);
</#if>
<#if item.isCloseEditView()>
        this.setCloseEditView(true);
</#if>
<#if item.getDataAccessAction()??>
        this.setDataAccessAction("${item.getDataAccessAction()}");
</#if>
<#if item.getSuccessMsg()??>
        this.setSuccessMsg("${srfjavastring('${item.getSuccessMsg()}')}");
</#if>
<#if item.isGlobalUIAction()>
        //全局界面行为
        this.setGlobalUIAction(true);
</#if>
<#if item.isEnableRuntimeModel()>
        //启用运行时模型支持
        this.setEnableRuntimeModel(true);
</#if>
   }

<#if item.isEnableRuntimeModel()>
   	/* (non-Javadoc)
	 * @see net.ibizsys.paas.demodel.DEUIActionModelBase#onFillRuntimeModelAjaxActionResult(net.ibizsys.paas.web.UIActionModelAjaxActionResult, org.hibernate.SessionFactory)
	 */
	@Override
	protected void onFillRuntimeModelAjaxActionResult(UIActionModelAjaxActionResult uiActionModelAjaxActionResult, SessionFactory sessionFactory) throws Exception {
		super.onFillRuntimeModelAjaxActionResult(uiActionModelAjaxActionResult, sessionFactory);
<#if item.getUIActionMode()??>
		uiActionModelAjaxActionResult.setUIActionMode("${srfjavastring('${item.getUIActionMode()}')}");
</#if>
<#if item.getActionTarget()??>
		uiActionModelAjaxActionResult.setUIActionTarget("${srfjavastring('${item.getActionTarget()}')}");
</#if>
<#if item.getUIActionTag()??>
		uiActionModelAjaxActionResult.setUIActionTag("${srfjavastring('${item.getUIActionTag()}')}");
</#if>		
		if (StringHelper.compare(uiActionModelAjaxActionResult.getUIActionMode(), IUIActionModel.ACTIONMODE_BACKEND, true) == 0 ) {
<#if item.getConfirmMsg()?? && item.getConfirmMsg()?length gt 0>
<#if item.getCMPSLanguageRes()??>
			if(WebContext.getCurrent()!=null){
				uiActionModelAjaxActionResult.setUIActionConfirmMsg(WebContext.getCurrent().getLocalization("${item.getCMPSLanguageRes().getLanResTag()}", "${srfjavastring('${item.getConfirmMsg()}')}"));
			}
			else{
				uiActionModelAjaxActionResult.setUIActionConfirmMsg("${srfjavastring('${item.getConfirmMsg()}')}");
			}
<#else>
			uiActionModelAjaxActionResult.setUIActionConfirmMsg("${srfjavastring('${item.getConfirmMsg()}')}");
</#if>
</#if>
		}
		
		if (StringHelper.compare(uiActionModelAjaxActionResult.getUIActionMode(), IUIActionModel.ACTIONMODE_FRONT, true) == 0){
<#if item.getFrontProcessType()??>
			uiActionModelAjaxActionResult.setUIActionFrontType("${srfjavastring('${item.getFrontProcessType()}')}");
</#if>
<#if item.getFrontPSDEViewId()?? && item.getFrontPSDEViewId()?length gt 0>			
			IAppViewModel iAppViewModel = null;
			IApplicationModel iIApplicationModel = null;
			if(ViewController.getCurrent()!=null){
				iIApplicationModel = ViewController.getCurrent().getAppModel();
				//尝试获取实体视图
				iAppViewModel = iIApplicationModel.getAppViewByDEViewId("${srfjavastring('${item.getFrontPSDEViewId()}')}", true);
			}
			if(iAppViewModel!=null && iIApplicationModel!=null){
				uiActionModelAjaxActionResult.setUIActionFrontViewTag(iIApplicationModel.getAppViewTag(iAppViewModel));
				uiActionModelAjaxActionResult.setUIActionFrontViewTitle(iAppViewModel.getTitle());
			}
</#if>
		}
	} 
</#if> 
 
}