<#ibiztemplate>
FILENAME=${item.codeName}DEModel.java
PUBOBJ=SubSysDEModelCodeBase
%PUBPKG%=${pub.getPKGCodeName()?replace('.','/')}
</#ibiztemplate>
package ${pub.getPKGCodeName()}.srv.subsys.demodel;


import java.io.Serializable;
import java.util.ArrayList;
import org.hibernate.SessionFactory;
import net.ibizsys.paas.core.DEDataSetCond;
import net.ibizsys.paas.logic.ICondition;
import net.ibizsys.paas.core.IDEDataSetCond;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;
import net.ibizsys.paas.core.ISystem;
import net.ibizsys.paas.demodel.DEModelGlobal;
import net.ibizsys.paas.sysmodel.SysModelGlobal;
import net.ibizsys.paas.service.IService;
import net.ibizsys.paas.service.ServiceGlobal;
import net.ibizsys.paas.view.IView;
import net.ibizsys.paas.core.IDEFSearchMode;
import net.ibizsys.paas.core.IDEField;
import net.ibizsys.paas.demodel.DEFSearchModeModel;
import net.ibizsys.paas.demodel.DEFieldModel;
import net.ibizsys.paas.demodel.DEMainStateModel;
import net.ibizsys.paas.core.IDEDataQuery;
import net.ibizsys.paas.core.IDEDataSet;
import net.ibizsys.paas.core.IDEAction;
import net.ibizsys.paas.core.IDEACMode;
import net.ibizsys.paas.core.IDELogic;
import net.ibizsys.paas.core.IDEUIAction;
import net.ibizsys.paas.core.IDEWF;
import net.ibizsys.paas.core.IDEMainState;
import net.ibizsys.paas.core.IDEDataImport;
import net.ibizsys.paas.report.IPrintService;
import net.ibizsys.paas.report.IReportService;
import ${pub.getPKGCodeName()}.srv.${sys.codeName}SysModel;


import ${de.getClassOrPkgName('SERVICE',pub)};
import ${de.getClassOrPkgName('DAO',pub)};
import ${de.getClassOrPkgName('ENTITY',pub)};


/**
 * ${item.logicName} 实体模型
 * 注意，此文件不能修改
 */
public class ${item.codeName}DEModel extends ${de.getClassOrPkgName('SUBSYS_DEMODEL',pub)}  {

   public ${item.codeName}DEModel() throws Exception {
        super();

        DEModelGlobal.registerDEModel("${pub.getPKGCodeName()}.srv.subsys.demodel.${item.codeName}DEModel",this);
   }

   private ${sys.codeName}SysModel ${srfparamname('${sys.codeName}')}SysModel;
      /**
       * 获取当前系统[${sys.codeName}]模型对象
       * @return
	   */
      public  ${sys.codeName}SysModel get${sys.codeName}SysModel() {
           if(this.${srfparamname('${sys.codeName}')}SysModel==null)
           {
               try
                {
                      this.${srfparamname('${sys.codeName}')}SysModel = (${sys.codeName}SysModel)SysModelGlobal.getSystem("${pub.getPKGCodeName()}.srv.${sys.codeName}SysModel");
                }
                catch(Exception ex)
                {
                }
           }       
           return this.${srfparamname('${sys.codeName}')}SysModel;
      }

	/**
     * 获取实体[${item.codeName}]模型对象
     * @return
     * @throws Exception
     */   
    public static ${item.codeName}DEModel getInstance() throws Exception{
    	return (${item.codeName}DEModel)DEModelGlobal.getDEModel(${item.codeName}DEModel.class);
    } 

  	@Override
  	public String getServiceId()
  	{
  		return "${pub.getPKGCodeName()}.srv.subsys.service.${item.codeName}Service";
  	}

	/* (non-Javadoc)
	 * @see net.ibizsys.paas.demodel.IDataEntityModel#createEntity()
	 */
	@Override
	public ${item.codeName} createEntity()
	{
		return new ${item.codeName}();
	}
	
   	/* (non-Javadoc)
	 * @see net.ibizsys.paas.demodel.DataEntityModelBase#prepareDEDataSets()
	 */
	@Override
	protected void prepareDEDataSets() throws Exception
	{
		super.prepareDEDataSets();
<#list item.getAllPSDEDataSets() as dedataset>
<#if dedataset.getExtendMode()==2>
                //注册  ${dedataset.name}
               IDEDataSet ${srfparamname('${dedataset.codeName}')}DSModel = (IDEDataSet)this.get${sys.codeName}SysModel().createObject("${pub.getPKGCodeName()}.srv.subsys.demodel.${item.codeName}${dedataset.codeName}DSModel");
               ${srfparamname('${dedataset.codeName}')}DSModel.init(this);
               this.registerDEDataSet(${srfparamname('${dedataset.codeName}')}DSModel);
</#if>        
</#list>
	}




	/* (non-Javadoc)
	 * @see net.ibizsys.paas.demodel.DataEntityModelBase#prepareDEDataQueries()
	 */
	@Override
	protected void prepareDEDataQueries() throws Exception
	{
		super.prepareDEDataQueries();
<#list item.getAllPSDEDataQueries() as dedataquery>
<#if dedataquery.getExtendMode()==2>
              //注册  ${dedataquery.name}
              IDEDataQuery ${srfparamname('${dedataquery.codeName}')}DQModel =(IDEDataQuery)this.get${sys.codeName}SysModel().createObject("${pub.getPKGCodeName()}.srv.subsys.demodel.${item.codeName}${dedataquery.codeName}DQModel");
               ${srfparamname('${dedataquery.codeName}')}DQModel.init(this);
               this.registerDEDataQuery(${srfparamname('${dedataquery.codeName}')}DQModel);
</#if> 
</#list>
	}

         /* (non-Javadoc)
	 * @see net.ibizsys.paas.demodel.DataEntityModelBase#prepareDEACModes()
	 */
        @Override
	protected void prepareDEACModes() throws Exception {
		super.prepareDEACModes();
<#list item.getAllPSDEACModes() as deacmode>
<#if deacmode.getExtendMode()==2>
		//注册  ${deacmode.name}
        IDEACMode ${srfparamname('${deacmode.codeName}')}ACMode =(IDEACMode)this.get${sys.codeName}SysModel().createObject("${pub.getPKGCodeName()}.srv.subsys.demodel.${item.codeName}${deacmode.codeName}ACModel");
        ${srfparamname('${deacmode.codeName}')}ACMode.init(this);
        this.registerDEACMode(${srfparamname('${deacmode.codeName}')}ACMode);
</#if> 
</#list>
	}

	/* (non-Javadoc)
	 * @see net.ibizsys.paas.demodel.DataEntityModelBase#prepareDEActions()
	 */
	@Override
	protected void prepareDEActions() throws Exception
	{
	super.prepareDEActions();
<#list item.getAllPSDEActions() as deaction>
<#if (deaction.actionType=='SYSDBPROC'&&deaction.getExtendMode()==2)>
               //注册  ${deaction.name}
               ${item.codeName}${deaction.codeName}DBProcModel ${srfparamname('${deaction.codeName}')}DBProcModel = new ${item.codeName}${deaction.codeName}DBProcModel();
               ${srfparamname('${deaction.codeName}')}DBProcModel.init(this);
               this.registerDEAction(${srfparamname('${deaction.codeName}')}DBProcModel);
</#if>
</#list>		
		
	}	
	
	/* (non-Javadoc)
	  * @see net.ibizsys.paas.demodel.DataEntityModelBase#prepareDEUIActions()
	 */
	@Override
	protected void prepareDEUIActions() throws Exception
	{
	super.prepareDEUIActions();
<#list item.getAllPSDEUIActions() as deuiaction>
<#if (deuiaction.getUIActionMode()=='BACKEND'&&deuiaction.getExtendMode()==2)>
       //注册  ${deuiaction.name}
       IDEUIAction ${srfparamname('${deuiaction.codeName}')}UIActionModel =(IDEUIAction)this.get${sys.codeName}SysModel().createObject("${pub.getPKGCodeName()}.srv.subsys.demodel.${item.codeName}${deuiaction.codeName}UIActionModel");
       ${srfparamname('${deuiaction.codeName}')}UIActionModel.init(this);
       this.registerDEUIAction(${srfparamname('${deuiaction.codeName}')}UIActionModel);
</#if>
</#list>		
	}	

/* (non-Javadoc)
	 * @see net.ibizsys.paas.demodel.DataEntityModelBase#prepareDELogics()
	 */
	@Override
	protected void prepareDELogics() throws Exception
	{
		super.prepareDELogics();
<#list item.getAllPSDELogics() as delogic>
<#if delogic.getExtendMode()==2>
               //注册  ${delogic.name}
               IDELogic ${srfparamname('${delogic.codeName}')}LogicModel = (IDELogic)this.get${sys.codeName}SysModel().createObject("${pub.getPKGCodeName()}.srv.subsys.demodel.${item.codeName}${delogic.codeName}LogicModel");
               ${srfparamname('${delogic.codeName}')}LogicModel.init(this);
               this.registerDELogic(${srfparamname('${delogic.codeName}')}LogicModel);
</#if>
</#list>
<#list item.getAllPSDEActions() as deaction>
<#if deaction.getPSDEActionLogics()??>
<#list deaction.getPSDEActionLogics() as actionlogic>
<#if actionlogic.isValid() && actionlogic.isInternalLogic() && actionlogic.getPSDELogic().getExtendMode()==2>
			this.registerDEActionLogic("${deaction.codeName?upper_case}","${actionlogic.getAttachMode()}","${actionlogic.getPSDELogic().codeName}");
</#if>
</#list>
 </#if>
</#list>
	}

	/* (non-Javadoc)
	 * @see net.ibizsys.paas.demodel.DataEntityModelBase#prepareDEPrints()
	 */
	@Override
	protected void prepareDEPrints()throws Exception
	{
		super.prepareDEPrints();
<#list item.getAllPSDEPrints()as deprint>
<#if deprint.getExtendMode()==2>
		//注册  ${deprint.name}
		IPrintService ${srfparamname('${deprint.codeName}')}PrintService = (IPrintService)this.get${sys.codeName}SysModel().createObject("${pub.getPKGCodeName()}.srv.subsys.demodel.${item.codeName}${deprint.codeName}PrintService");
		${srfparamname('${deprint.codeName}')}PrintService.init(this);
</#if>
</#list>
	}

	/* (non-Javadoc)
	 * @see net.ibizsys.paas.demodel.DataEntityModelBase#prepareDEFields()
	 */
	@Override
	protected void prepareDEFields() throws Exception
	{
		super.prepareDEFields();
		IDEField iDEField = null;
		IDEFSearchMode iDEFSearchMode = null;
<#list item.getPSDEFields() as defield>
		//注册属性 "${defield.name}"
		iDEField = this.createDEField("${defield.name}");
		if(iDEField==null)
		{
			DEFieldModel deFieldModel = new DEFieldModel();
			deFieldModel.setDataEntity(this);
			deFieldModel.setId("${defield.id}");
			deFieldModel.setName("${defield.name}");
			deFieldModel.setLogicName("${defield.logicName}");
			deFieldModel.setDataType("${defield.dataType}");
			deFieldModel.setStdDataType(${defield.stdDataType?c});
	<#if (defield.isKeyDEField())>
			deFieldModel.setKeyDEField(true);
	</#if>		
	<#if (defield.isUniTagField())>
			deFieldModel.setUniTagField(true);
	</#if>
	<#if (defield.isEnableDBAutoValue())>
			deFieldModel.setEnableDBAutoValue(true);
	</#if>
	<#if (defield.isMajorDEField())>
			deFieldModel.setMajorDEField(true);
	</#if>	
	<#if (defield.getUnionKeyValue()??) && (defield.getUnionKeyValue()?length gt 0)>
            deFieldModel.setUnionKeyValue("${defield.getUnionKeyValue()}");
	</#if>	
	<#if (defield.isLinkDEField())>
			deFieldModel.setLinkDEField(true);
	</#if>	
	<#if (defield.isInheritDEField())>
			deFieldModel.setInheritDEField(true);
	</#if>	
	<#if (defield.isMultiFormDEField())>
			deFieldModel.setMultiFormDEField(true);
	</#if>	
	<#if (defield.isIndexTypeDEField())>
			deFieldModel.setIndexTypeDEField(true);
	</#if>
			deFieldModel.setImportOrder(${defield.getImportOrder()?c});
			deFieldModel.setImportTag("${defield.getImportTag()}");
	<#if defield.getDERName()??>
			deFieldModel.setDERName("${defield.getDERName()}");
	</#if>
	<#if defield.getLinkDEFName()??>
			deFieldModel.setLinkDEFName("${defield.getLinkDEFName()}");
	</#if>
	<#if (!defield.isPhisicalDEField())>
			deFieldModel.setPhisicalDEField(false);
	</#if>	
	<#if (defield.isFormulaDEField())>
			deFieldModel.setFormulaDEField(true);
	</#if>
	<#if (defield.getPreDefinedType()??) && (defield.getPreDefinedType()?length gt 0)>
			deFieldModel.setPreDefinedType("${defield.getPreDefinedType()}");
	</#if>
	<#if defield.isEnableDBValueInsertUpdateMode()>
		<#if (defield.getDBValueInsertMode()??) && (defield.getDBValueInsertMode()?length gt 0)>
			deFieldModel.setDBValueInsertMode("${defield.getDBValueInsertMode()}");
		</#if>
		<#if (defield.getDBValueUpdateMode()??) && (defield.getDBValueUpdateMode()?length gt 0)>
			deFieldModel.setDBValueUpdateMode("${defield.getDBValueUpdateMode()}");
		</#if>
		<#list defield.getAllPSDEFDTColumns() as dtcolumn>
			<#if (dtcolumn.getInsertValueFunc()??) && (dtcolumn.getInsertValueFunc()?length gt 0)>
			deFieldModel.registerDBValueFuncCode("${dtcolumn.getPSDEDBConfig().getDBType()}", true,"${dtcolumn.getInsertValueFunc()}", "${dtcolumn.getInsertValueFuncField()}");
			</#if>
			<#if (dtcolumn.getUpdateValueFunc()??) && (dtcolumn.getUpdateValueFunc()?length gt 0)>
			deFieldModel.registerDBValueFuncCode("${dtcolumn.getPSDEDBConfig().getDBType()}", false,"${dtcolumn.getUpdateValueFunc()}", "${dtcolumn.getUpdateValueFuncField()}");
			</#if>  
		</#list> 
	<#else>
		<#if (defield.getDBValueFunc()??) && (defield.getDBValueFunc()?length gt 0)>
			deFieldModel.setDBValueFunc("${defield.getDBValueFunc()}");
		</#if>
	</#if>
	<#if (defield.getPSCodeList()??)>
			deFieldModel.setCodeListId("${defield.getPSCodeList().getClassOrPkgName('CODELIST',pub)}");
	</#if>
	<#if (defield.getValueFormat()??)>
			deFieldModel.setValueFormat("${defield.getValueFormat()}");
	</#if>
	<#if (defield.isEnableAudit())>
			deFieldModel.setEnableAudit(true);
	<#if ((defield.getAuditInfoFormat()??)&&(defield.getAuditInfoFormat()?length gt 0))>
			deFieldModel.setAuditInfoFormat("${srfjavastring('${defield.getAuditInfoFormat()}')}");
	</#if>
	</#if>
	<#if item.isEnableTempData()&&!defield.isEnableTempData()>
			deFieldModel.setEnableTempData(false);
	</#if>
	<#list defield.getAllPSDEFSearchModes() as searchmode>
	<#if searchmode.getExtendMode()==2>
			iDEFSearchMode = this.createDEFSearchMode(deFieldModel,"${srfxmlvalue('${searchmode.name}')}");
			if(iDEFSearchMode==null)
			{
				DEFSearchModeModel defSearchModeModel = new DEFSearchModeModel();
				defSearchModeModel.setDEField(deFieldModel);
				defSearchModeModel.setName("${srfxmlvalue('${searchmode.name}')}");
		<#if (searchmode.getValueFunc()??) && (searchmode.getValueFunc()?length gt 0)>
				defSearchModeModel.setValueFunc("${srfxmlvalue('${searchmode.valueFunc}')}");
		</#if>
				defSearchModeModel.setValueOp("${srfxmlvalue('${searchmode.valueOp}')}");
				defSearchModeModel.init();
				deFieldModel.registerDEFSearchMode(defSearchModeModel);
			}
	</#if>
	</#list>
	<#list defield.getAllPSDEFDTColumns() as defdtcolumn>
		<#if defdtcolumn.isCustomColumnName()>
			net.ibizsys.paas.demodel.DEFDTColumnModel ${srfparamname('${defdtcolumn.getDBType()}')}DEFDTColumnModel = new net.ibizsys.paas.demodel.DEFDTColumnModel();
			${srfparamname('${defdtcolumn.getDBType()}')}DEFDTColumnModel.setDBType("${defdtcolumn.getDBType()}");
			${srfparamname('${defdtcolumn.getDBType()}')}DEFDTColumnModel.setColumnName("${defdtcolumn.getColumnName()}");
			deFieldModel.registerDEFDTColumn(${srfparamname('${defdtcolumn.getDBType()}')}DEFDTColumnModel);
		</#if>
	</#list>
			deFieldModel.init();
			iDEField = deFieldModel;
		}
		this.registerDEField(iDEField);
</#list>
		
<#if item.getDEMainStateDEFields()??>
		this.setMainStateFields(new String[] {<#list item.getDEMainStateDEFields() as demsfield><#if (demsfield_index gt 0) >,</#if>"${demsfield.name?lower_case}"</#list>});
</#if>
	}

}