<#ibiztemplate>
FILENAME=${item.codeName}Service.java
PUBOBJ=SubSysDEServiceBaseCode
MODELS=PSDATAENTITY
%PUBPKG%=${pub.getPKGCodeName()?replace('.','/')}
</#ibiztemplate>
package ${pub.getPKGCodeName()}.srv.subsys.service;


import java.util.ArrayList;
import java.util.List;
import java.util.HashMap;

import org.hibernate.Session;
import org.hibernate.SessionFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Repository;
import org.springframework.transaction.annotation.Transactional;
import net.ibizsys.paas.exception.ErrorException;
import net.ibizsys.paas.core.IDataEntity;
import net.ibizsys.paas.core.PluginActionResult;
import net.ibizsys.paas.core.IDEDataSetFetchContext;
import net.ibizsys.paas.db.DBCallResult;
import net.ibizsys.paas.db.DBFetchResult;
import net.ibizsys.paas.db.IProcParam;
import net.ibizsys.paas.util.StringHelper;
import net.ibizsys.paas.util.StringBuilderEx;
import net.ibizsys.paas.core.Errors;
import net.ibizsys.paas.api.IServiceAPIAction;
import net.ibizsys.paas.core.ActionContext;
import net.ibizsys.paas.data.DataObject;
import net.ibizsys.paas.service.ServiceGlobal;
import net.ibizsys.paas.entity.IEntity;
import net.ibizsys.paas.demodel.IDataEntityModel;
import net.ibizsys.paas.demodel.DEModelGlobal;
import net.ibizsys.paas.demodel.IDELogicModel;
import net.ibizsys.paas.dao.DAOGlobal;
import net.ibizsys.paas.web.WebContext;
import net.ibizsys.paas.service.IService;
import net.ibizsys.paas.service.IServicePlugin;
import net.ibizsys.paas.util.DataTypeHelper;
import net.ibizsys.paas.util.KeyValueHelper;
import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import net.ibizsys.paas.db.SelectCond;
import net.ibizsys.paas.service.IServiceWork;
import net.ibizsys.paas.service.ITransaction;
import net.ibizsys.paas.dao.IDAO;
import net.ibizsys.paas.service.CloneSession;
import net.ibizsys.paas.service.ServiceBase;
import net.ibizsys.paas.entity.EntityFieldError;
import net.ibizsys.paas.entity.EntityError;
import java.sql.Timestamp;
import net.ibizsys.paas.util.DefaultValueHelper;
import javax.annotation.PostConstruct;
import net.ibizsys.paas.service.IDataContextParam;
import net.sf.json.JSONObject;
import org.springframework.stereotype.Component;
import net.ibizsys.paas.service.ServiceGlobal;



import ${de.getClassOrPkgName('DEMODEL',pub)};
import ${de.getClassOrPkgName('DAO',pub)};
import ${de.getClassOrPkgName('ENTITY',pub)};

<#assign entityname=item.codeName>
<#assign preparelastforupdate=0>
/**
 * ${item.logicName} 服务对象基类
 * 注意，此文件不能修改
 * 
 */
@Component
public class ${item.codeName}Service extends ${de.getClassOrPkgName('SUBSYS_SERVICE',pub)}{

<#list item.getAllPSDEDataSets() as dedataset>
<#if dedataset.getExtendMode()==2>
   public final static String DATASET_${dedataset.name?upper_case} = "${dedataset.name}";
</#if>
</#list>

<#list item.getAllPSDEActions() as deaction>
<#if deaction.actionType!='BUILTIN'&&deaction.getExtendMode()==2>	
	/**
	 * 实体行为[${deaction.logicName}]标识
	 */
   public final static String ACTION_${deaction.name?upper_case} = "${deaction.name}";
</#if>
</#list>

   public ${item.codeName}Service (){
        super();
       
   }
   
    /**
     * 获取实体[${item.codeName}]服务对象
     * @return
     * @throws Exception
     */   
    public static ${item.codeName}Service getInstance() throws Exception{
    	return getInstance(null);
    }
    
    /**
     * 获取实体[${item.codeName}]服务对象
     * @param sessionFactory
     * @return
     * @throws Exception
     */
    public static ${item.codeName}Service getInstance(SessionFactory sessionFactory) throws Exception{
    	return (${item.codeName}Service)ServiceGlobal.getService(${item.codeName}Service.class, sessionFactory);
    }
   

   @PostConstruct  
   public void postConstruct() throws Exception{    
	   super.postConstruct();
	   ServiceGlobal.registerService("${de.getClassOrPkgName('SERVICE',pub)}", this);
           <#comment>  
	   ServiceGlobal.registerService("${de.getClassOrPkgName('SERVICE',pub)}",IDataEntity.DSLINK_DEFAULT,this);
           </#comment>
   }     


               
    /**
	 * 获取数据集合
	 * @param strDataSetName
	 * @param iDEDataSetFetchContext
	 * @return
	 * @throws Exception
	 */
        @Override
	protected DBFetchResult onfetchDataSet(String strDataSetName,IDEDataSetFetchContext iDEDataSetFetchContext) throws Exception
	{
<#list item.getAllPSDEDataSets() as dedataset>
<#if dedataset.getExtendMode()==2>
              if(StringHelper.compare(strDataSetName,DATASET_${dedataset.name?upper_case},true)==0){
                   return this.fetch${dedataset.codeName}(iDEDataSetFetchContext);
              }
</#if>
</#list>
              return super.onfetchDataSet(strDataSetName,iDEDataSetFetchContext);
	}

<#if de.isEnableTempData()>
    /**
     * 获取数据集合
   	 * @param strDataSetName
   	 * @param iDEDataSetFetchContext
   	 * @return
   	 * @throws Exception
   	 */
    @Override
   	protected DBFetchResult onfetchDataSetTemp(String strDataSetName,IDEDataSetFetchContext iDEDataSetFetchContext) throws Exception
   	{
   <#list item.getAllPSDEDataSets() as dedataset>
   <#if dedataset.getExtendMode()==2>
         if(StringHelper.compare(strDataSetName,DATASET_${dedataset.name?upper_case},true)==0){
                return this.fetchTemp${dedataset.codeName}(iDEDataSetFetchContext);
         }
   </#if>
   </#list>
         return super.onfetchDataSetTemp(strDataSetName,iDEDataSetFetchContext);
   	}
</#if>
	
	/* (non-Javadoc)
	 * @see net.ibizsys.paas.service.ServiceBase#onExecuteAction(java.lang.String, net.ibizsys.paas.entity.IEntity)
	 */
   	@Override
	protected  void onExecuteAction(String strAction,IEntity entity) throws Exception
	{
<#list item.getAllPSDEActions() as deaction>
<#if deaction.actionType!='BUILTIN'&&deaction.getExtendMode()==2>
              if(StringHelper.compare(strAction,ACTION_${deaction.name?upper_case},true)==0){
                   this.${srfmethodname('${deaction.codeName}')}((${entityname})entity);
                   return;
              }
</#if>
</#list>  
            super.onExecuteAction(strAction,entity);
	}

<#list fetchdedatasets as fetchdedataset>
    ${fetchdedataset.code}

</#list>   

<#list item.getAllPSDEActions() as deaction>
<#if deaction.getActionType()=='USERCUSTOM'&&deaction.getExtendMode()==2>
<#if deaction.getPSDEActionTempl()?? && deaction.getPSDEActionTempl().hasCode()>
   ${deaction.getPSDEActionTempl().getCode(deaction)}
<#else>
   /**
    * 执行操作[${deaction.codeName}]
    */
   public void ${srfmethodname('${deaction.codeName}')}(${entityname} ${srfparamname('${item.codeName}')}) throws Exception{

	   if(this.isUseServiceAPI()){
			this.getServiceAPIClientModel().execute(this.getDEModel().getServiceAPIActionTag(IServiceAPIAction.ACTIONTYPE_DEACTION, ACTION_${deaction.name?upper_case}), ${srfparamname('${item.codeName}')});
			return;
		}
	   
	   final IServicePlugin iServicePlugin = getPlugin();
		if(iServicePlugin!=null && iServicePlugin.doCustomAction(this,ACTION_${deaction.name?upper_case}, IServicePlugin.ACTIONPOS_ENTER,${srfparamname('${item.codeName}')},null).getResult()==PluginActionResult.RESULT_REPLACE)
			return;
		this.testDEMainStateAction(${srfparamname('${item.codeName}')},ACTION_${deaction.name?upper_case});
		final ${entityname} ${srfparamname('${item.codeName}')}2 = ${srfparamname('${item.codeName}')};
	   this.doServiceWork(new IServiceWork()
	   {
			@Override
			public void execute(ITransaction iTransaction) throws Exception
			{
				if(iServicePlugin==null || iServicePlugin.doCustomAction(getService(),ACTION_${deaction.name?upper_case}, IServicePlugin.ACTIONPOS_ACTION,${srfparamname('${item.codeName}')}2,null).getResult()!=PluginActionResult.RESULT_REPLACE)
					on${deaction.codeName}(${srfparamname('${item.codeName}')}2);
			}
	   }); 
	   
	   if(iServicePlugin!=null)
			iServicePlugin.doCustomAction(this,ACTION_${deaction.name?upper_case},IServicePlugin.ACTIONPOS_LEAVE,${srfparamname('${item.codeName}')},null);
   }
   
   /*
    * 执行操作[${deaction.codeName}]
    */
   protected void on${deaction.codeName}(${entityname} ${srfparamname('${item.codeName}')}) throws Exception{

	     throw new Exception("没有实现自定义行为[${deaction.name}]");
   }
   
</#if>
</#if>
</#list>  

<#list item.getAllPSDEActions() as deaction>
<#if deaction.getActionType()=='DELOGIC'&&deaction.getExtendMode()==2>
   /**
    * 执行操作[${deaction.codeName}]
    */
   public void ${srfmethodname('${deaction.codeName}')}(${entityname} ${srfparamname('${item.codeName}')}) throws Exception{

	   final ${entityname} et = ${srfparamname('${item.codeName}')};
	   et.setSessionFactory(this.getSessionFactory());
	   this.testDEMainStateAction(${srfparamname('${item.codeName}')},ACTION_${deaction.name?upper_case});
	   final IDELogicModel iDELogicModel = (IDELogicModel ) this.get${item.codeName}DEModel().getDELogic("${deaction.getPSDELogic().codeName}");
	   this.doServiceWork(new IServiceWork()
	   {
			@Override
			public void execute(ITransaction iTransaction) throws Exception
			{
				ActionContext actionContextImpl = new ActionContext(null);
				actionContextImpl.setParam(iDELogicModel.getDefaultParamName(), et);
				actionContextImpl.setSessionFactory(getSessionFactory());
				iDELogicModel.execute(actionContextImpl);
			}
	   });
   }
</#if>
</#list>  

}